=begin
#API v1

#FormAPI is a service that helps you fill out and sign PDF templates.

OpenAPI spec version: v1

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 3.3.0-SNAPSHOT

=end

require 'uri'

module FormAPI
  class PDFApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Generates multiple PDFs
    # @param template_id 
    # @param request_body 
    # @param [Hash] opts the optional parameters
    # @return [Array<CreateSubmissionResponse>]
    def batch_generate_pdf_v1(template_id, request_body, opts = {})
      data, _status_code, _headers = batch_generate_pdf_v1_with_http_info(template_id, request_body, opts)
      data
    end

    # Generates multiple PDFs
    # @param template_id 
    # @param request_body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<CreateSubmissionResponse>, Fixnum, Hash)>] Array<CreateSubmissionResponse> data, response status code and response headers
    def batch_generate_pdf_v1_with_http_info(template_id, request_body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.batch_generate_pdf_v1 ...'
      end
      # verify the required parameter 'template_id' is set
      if @api_client.config.client_side_validation && template_id.nil?
        fail ArgumentError, "Missing the required parameter 'template_id' when calling PDFApi.batch_generate_pdf_v1"
      end
      # verify the required parameter 'request_body' is set
      if @api_client.config.client_side_validation && request_body.nil?
        fail ArgumentError, "Missing the required parameter 'request_body' when calling PDFApi.batch_generate_pdf_v1"
      end
      # resource path
      local_var_path = '/templates/{template_id}/submissions/batch'.sub('{' + 'template_id' + '}', template_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(request_body)
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<CreateSubmissionResponse>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#batch_generate_pdf_v1\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Generates multiple PDFs
    # @param submission_batch_data 
    # @param [Hash] opts the optional parameters
    # @return [CreateSubmissionBatchResponse]
    def batch_generate_pdfs(submission_batch_data, opts = {})
      data, _status_code, _headers = batch_generate_pdfs_with_http_info(submission_batch_data, opts)
      data
    end

    # Generates multiple PDFs
    # @param submission_batch_data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CreateSubmissionBatchResponse, Fixnum, Hash)>] CreateSubmissionBatchResponse data, response status code and response headers
    def batch_generate_pdfs_with_http_info(submission_batch_data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.batch_generate_pdfs ...'
      end
      # verify the required parameter 'submission_batch_data' is set
      if @api_client.config.client_side_validation && submission_batch_data.nil?
        fail ArgumentError, "Missing the required parameter 'submission_batch_data' when calling PDFApi.batch_generate_pdfs"
      end
      # resource path
      local_var_path = '/submissions/batches'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(submission_batch_data)
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CreateSubmissionBatchResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#batch_generate_pdfs\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Merge submission PDFs, template PDFs, or custom files
    # @param combine_pdfs_data 
    # @param [Hash] opts the optional parameters
    # @return [CreateCombinedSubmissionResponse]
    def combine_pdfs(combine_pdfs_data, opts = {})
      data, _status_code, _headers = combine_pdfs_with_http_info(combine_pdfs_data, opts)
      data
    end

    # Merge submission PDFs, template PDFs, or custom files
    # @param combine_pdfs_data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CreateCombinedSubmissionResponse, Fixnum, Hash)>] CreateCombinedSubmissionResponse data, response status code and response headers
    def combine_pdfs_with_http_info(combine_pdfs_data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.combine_pdfs ...'
      end
      # verify the required parameter 'combine_pdfs_data' is set
      if @api_client.config.client_side_validation && combine_pdfs_data.nil?
        fail ArgumentError, "Missing the required parameter 'combine_pdfs_data' when calling PDFApi.combine_pdfs"
      end
      # resource path
      local_var_path = '/combined_submissions?v=2'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(combine_pdfs_data)
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CreateCombinedSubmissionResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#combine_pdfs\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Merge generated PDFs together
    # @param combined_submission_data 
    # @param [Hash] opts the optional parameters
    # @return [CreateCombinedSubmissionResponse]
    def combine_submissions(combined_submission_data, opts = {})
      data, _status_code, _headers = combine_submissions_with_http_info(combined_submission_data, opts)
      data
    end

    # Merge generated PDFs together
    # @param combined_submission_data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CreateCombinedSubmissionResponse, Fixnum, Hash)>] CreateCombinedSubmissionResponse data, response status code and response headers
    def combine_submissions_with_http_info(combined_submission_data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.combine_submissions ...'
      end
      # verify the required parameter 'combined_submission_data' is set
      if @api_client.config.client_side_validation && combined_submission_data.nil?
        fail ArgumentError, "Missing the required parameter 'combined_submission_data' when calling PDFApi.combine_submissions"
      end
      # resource path
      local_var_path = '/combined_submissions'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(combined_submission_data)
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CreateCombinedSubmissionResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#combine_submissions\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create a new custom file from a cached presign upload
    # @param create_custom_file_data 
    # @param [Hash] opts the optional parameters
    # @return [CreateCustomFileResponse]
    def create_custom_file_from_upload(create_custom_file_data, opts = {})
      data, _status_code, _headers = create_custom_file_from_upload_with_http_info(create_custom_file_data, opts)
      data
    end

    # Create a new custom file from a cached presign upload
    # @param create_custom_file_data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CreateCustomFileResponse, Fixnum, Hash)>] CreateCustomFileResponse data, response status code and response headers
    def create_custom_file_from_upload_with_http_info(create_custom_file_data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.create_custom_file_from_upload ...'
      end
      # verify the required parameter 'create_custom_file_data' is set
      if @api_client.config.client_side_validation && create_custom_file_data.nil?
        fail ArgumentError, "Missing the required parameter 'create_custom_file_data' when calling PDFApi.create_custom_file_from_upload"
      end
      # resource path
      local_var_path = '/custom_files'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(create_custom_file_data)
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CreateCustomFileResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#create_custom_file_from_upload\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Creates a new data request token for form authentication
    # @param data_request_id 
    # @param [Hash] opts the optional parameters
    # @return [CreateSubmissionDataRequestTokenResponse]
    def create_data_request_token(data_request_id, opts = {})
      data, _status_code, _headers = create_data_request_token_with_http_info(data_request_id, opts)
      data
    end

    # Creates a new data request token for form authentication
    # @param data_request_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CreateSubmissionDataRequestTokenResponse, Fixnum, Hash)>] CreateSubmissionDataRequestTokenResponse data, response status code and response headers
    def create_data_request_token_with_http_info(data_request_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.create_data_request_token ...'
      end
      # verify the required parameter 'data_request_id' is set
      if @api_client.config.client_side_validation && data_request_id.nil?
        fail ArgumentError, "Missing the required parameter 'data_request_id' when calling PDFApi.create_data_request_token"
      end
      # resource path
      local_var_path = '/data_requests/{data_request_id}/tokens'.sub('{' + 'data_request_id' + '}', data_request_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CreateSubmissionDataRequestTokenResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#create_data_request_token\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create a folder
    # @param create_folder_data 
    # @param [Hash] opts the optional parameters
    # @return [Folder]
    def create_folder(create_folder_data, opts = {})
      data, _status_code, _headers = create_folder_with_http_info(create_folder_data, opts)
      data
    end

    # Create a folder
    # @param create_folder_data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Folder, Fixnum, Hash)>] Folder data, response status code and response headers
    def create_folder_with_http_info(create_folder_data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.create_folder ...'
      end
      # verify the required parameter 'create_folder_data' is set
      if @api_client.config.client_side_validation && create_folder_data.nil?
        fail ArgumentError, "Missing the required parameter 'create_folder_data' when calling PDFApi.create_folder"
      end
      # resource path
      local_var_path = '/folders/'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(create_folder_data)
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Folder')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#create_folder\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Upload a new PDF template with a file upload
    # @param template_document 
    # @param template_name 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :template_parent_folder_id 
    # @return [PendingTemplate]
    def create_template(template_document, template_name, opts = {})
      data, _status_code, _headers = create_template_with_http_info(template_document, template_name, opts)
      data
    end

    # Upload a new PDF template with a file upload
    # @param template_document 
    # @param template_name 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :template_parent_folder_id 
    # @return [Array<(PendingTemplate, Fixnum, Hash)>] PendingTemplate data, response status code and response headers
    def create_template_with_http_info(template_document, template_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.create_template ...'
      end
      # verify the required parameter 'template_document' is set
      if @api_client.config.client_side_validation && template_document.nil?
        fail ArgumentError, "Missing the required parameter 'template_document' when calling PDFApi.create_template"
      end
      # verify the required parameter 'template_name' is set
      if @api_client.config.client_side_validation && template_name.nil?
        fail ArgumentError, "Missing the required parameter 'template_name' when calling PDFApi.create_template"
      end
      # resource path
      local_var_path = '/templates'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['multipart/form-data'])

      # form parameters
      form_params = {}
      form_params['template[document]'] = template_document
      form_params['template[name]'] = template_name
      form_params['template[parent_folder_id]'] = opts[:'template_parent_folder_id'] if !opts[:'template_parent_folder_id'].nil?

      # http body (model)
      post_body = nil
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PendingTemplate')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#create_template\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create a new PDF template from a cached presign upload
    # @param create_template_data 
    # @param [Hash] opts the optional parameters
    # @return [PendingTemplate]
    def create_template_from_upload(create_template_data, opts = {})
      data, _status_code, _headers = create_template_from_upload_with_http_info(create_template_data, opts)
      data
    end

    # Create a new PDF template from a cached presign upload
    # @param create_template_data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PendingTemplate, Fixnum, Hash)>] PendingTemplate data, response status code and response headers
    def create_template_from_upload_with_http_info(create_template_data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.create_template_from_upload ...'
      end
      # verify the required parameter 'create_template_data' is set
      if @api_client.config.client_side_validation && create_template_data.nil?
        fail ArgumentError, "Missing the required parameter 'create_template_data' when calling PDFApi.create_template_from_upload"
      end
      # resource path
      local_var_path = '/templates?v=2'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(create_template_data)
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'PendingTemplate')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#create_template_from_upload\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a folder
    # @param folder_id 
    # @param [Hash] opts the optional parameters
    # @return [Folder]
    def delete_folder(folder_id, opts = {})
      data, _status_code, _headers = delete_folder_with_http_info(folder_id, opts)
      data
    end

    # Delete a folder
    # @param folder_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Folder, Fixnum, Hash)>] Folder data, response status code and response headers
    def delete_folder_with_http_info(folder_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.delete_folder ...'
      end
      # verify the required parameter 'folder_id' is set
      if @api_client.config.client_side_validation && folder_id.nil?
        fail ArgumentError, "Missing the required parameter 'folder_id' when calling PDFApi.delete_folder"
      end
      # resource path
      local_var_path = '/folders/{folder_id}'.sub('{' + 'folder_id' + '}', folder_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Folder')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#delete_folder\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Expire a combined submission
    # @param combined_submission_id 
    # @param [Hash] opts the optional parameters
    # @return [CombinedSubmission]
    def expire_combined_submission(combined_submission_id, opts = {})
      data, _status_code, _headers = expire_combined_submission_with_http_info(combined_submission_id, opts)
      data
    end

    # Expire a combined submission
    # @param combined_submission_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CombinedSubmission, Fixnum, Hash)>] CombinedSubmission data, response status code and response headers
    def expire_combined_submission_with_http_info(combined_submission_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.expire_combined_submission ...'
      end
      # verify the required parameter 'combined_submission_id' is set
      if @api_client.config.client_side_validation && combined_submission_id.nil?
        fail ArgumentError, "Missing the required parameter 'combined_submission_id' when calling PDFApi.expire_combined_submission"
      end
      # resource path
      local_var_path = '/combined_submissions/{combined_submission_id}'.sub('{' + 'combined_submission_id' + '}', combined_submission_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CombinedSubmission')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#expire_combined_submission\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Expire a PDF submission
    # @param submission_id 
    # @param [Hash] opts the optional parameters
    # @return [Submission]
    def expire_submission(submission_id, opts = {})
      data, _status_code, _headers = expire_submission_with_http_info(submission_id, opts)
      data
    end

    # Expire a PDF submission
    # @param submission_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Submission, Fixnum, Hash)>] Submission data, response status code and response headers
    def expire_submission_with_http_info(submission_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.expire_submission ...'
      end
      # verify the required parameter 'submission_id' is set
      if @api_client.config.client_side_validation && submission_id.nil?
        fail ArgumentError, "Missing the required parameter 'submission_id' when calling PDFApi.expire_submission"
      end
      # resource path
      local_var_path = '/submissions/{submission_id}'.sub('{' + 'submission_id' + '}', submission_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Submission')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#expire_submission\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Generates a new PDF
    # @param template_id 
    # @param submission_data 
    # @param [Hash] opts the optional parameters
    # @return [CreateSubmissionResponse]
    def generate_pdf(template_id, submission_data, opts = {})
      data, _status_code, _headers = generate_pdf_with_http_info(template_id, submission_data, opts)
      data
    end

    # Generates a new PDF
    # @param template_id 
    # @param submission_data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CreateSubmissionResponse, Fixnum, Hash)>] CreateSubmissionResponse data, response status code and response headers
    def generate_pdf_with_http_info(template_id, submission_data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.generate_pdf ...'
      end
      # verify the required parameter 'template_id' is set
      if @api_client.config.client_side_validation && template_id.nil?
        fail ArgumentError, "Missing the required parameter 'template_id' when calling PDFApi.generate_pdf"
      end
      # verify the required parameter 'submission_data' is set
      if @api_client.config.client_side_validation && submission_data.nil?
        fail ArgumentError, "Missing the required parameter 'submission_data' when calling PDFApi.generate_pdf"
      end
      # resource path
      local_var_path = '/templates/{template_id}/submissions'.sub('{' + 'template_id' + '}', template_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(submission_data)
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CreateSubmissionResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#generate_pdf\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Check the status of a combined submission (merged PDFs)
    # @param combined_submission_id 
    # @param [Hash] opts the optional parameters
    # @return [CombinedSubmission]
    def get_combined_submission(combined_submission_id, opts = {})
      data, _status_code, _headers = get_combined_submission_with_http_info(combined_submission_id, opts)
      data
    end

    # Check the status of a combined submission (merged PDFs)
    # @param combined_submission_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CombinedSubmission, Fixnum, Hash)>] CombinedSubmission data, response status code and response headers
    def get_combined_submission_with_http_info(combined_submission_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.get_combined_submission ...'
      end
      # verify the required parameter 'combined_submission_id' is set
      if @api_client.config.client_side_validation && combined_submission_id.nil?
        fail ArgumentError, "Missing the required parameter 'combined_submission_id' when calling PDFApi.get_combined_submission"
      end
      # resource path
      local_var_path = '/combined_submissions/{combined_submission_id}'.sub('{' + 'combined_submission_id' + '}', combined_submission_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'CombinedSubmission')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#get_combined_submission\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Look up a submission data request
    # @param data_request_id 
    # @param [Hash] opts the optional parameters
    # @return [SubmissionDataRequest]
    def get_data_request(data_request_id, opts = {})
      data, _status_code, _headers = get_data_request_with_http_info(data_request_id, opts)
      data
    end

    # Look up a submission data request
    # @param data_request_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(SubmissionDataRequest, Fixnum, Hash)>] SubmissionDataRequest data, response status code and response headers
    def get_data_request_with_http_info(data_request_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.get_data_request ...'
      end
      # verify the required parameter 'data_request_id' is set
      if @api_client.config.client_side_validation && data_request_id.nil?
        fail ArgumentError, "Missing the required parameter 'data_request_id' when calling PDFApi.get_data_request"
      end
      # resource path
      local_var_path = '/data_requests/{data_request_id}'.sub('{' + 'data_request_id' + '}', data_request_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'SubmissionDataRequest')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#get_data_request\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get a presigned URL so that you can upload a file to our AWS S3 bucket
    # @param [Hash] opts the optional parameters
    # @return [Hash<String, Object>]
    def get_presign_url(opts = {})
      data, _status_code, _headers = get_presign_url_with_http_info(opts)
      data
    end

    # Get a presigned URL so that you can upload a file to our AWS S3 bucket
    # @param [Hash] opts the optional parameters
    # @return [Array<(Hash<String, Object>, Fixnum, Hash)>] Hash<String, Object> data, response status code and response headers
    def get_presign_url_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.get_presign_url ...'
      end
      # resource path
      local_var_path = '/uploads/presign'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Hash<String, Object>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#get_presign_url\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Check the status of a PDF
    # @param submission_id 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :include_data 
    # @return [Submission]
    def get_submission(submission_id, opts = {})
      data, _status_code, _headers = get_submission_with_http_info(submission_id, opts)
      data
    end

    # Check the status of a PDF
    # @param submission_id 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :include_data 
    # @return [Array<(Submission, Fixnum, Hash)>] Submission data, response status code and response headers
    def get_submission_with_http_info(submission_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.get_submission ...'
      end
      # verify the required parameter 'submission_id' is set
      if @api_client.config.client_side_validation && submission_id.nil?
        fail ArgumentError, "Missing the required parameter 'submission_id' when calling PDFApi.get_submission"
      end
      # resource path
      local_var_path = '/submissions/{submission_id}'.sub('{' + 'submission_id' + '}', submission_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'include_data'] = opts[:'include_data'] if !opts[:'include_data'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Submission')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#get_submission\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Check the status of a submission batch job
    # @param submission_batch_id 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :include_submissions 
    # @return [SubmissionBatch]
    def get_submission_batch(submission_batch_id, opts = {})
      data, _status_code, _headers = get_submission_batch_with_http_info(submission_batch_id, opts)
      data
    end

    # Check the status of a submission batch job
    # @param submission_batch_id 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :include_submissions 
    # @return [Array<(SubmissionBatch, Fixnum, Hash)>] SubmissionBatch data, response status code and response headers
    def get_submission_batch_with_http_info(submission_batch_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.get_submission_batch ...'
      end
      # verify the required parameter 'submission_batch_id' is set
      if @api_client.config.client_side_validation && submission_batch_id.nil?
        fail ArgumentError, "Missing the required parameter 'submission_batch_id' when calling PDFApi.get_submission_batch"
      end
      # resource path
      local_var_path = '/submissions/batches/{submission_batch_id}'.sub('{' + 'submission_batch_id' + '}', submission_batch_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'include_submissions'] = opts[:'include_submissions'] if !opts[:'include_submissions'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'SubmissionBatch')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#get_submission_batch\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get a single template
    # @param template_id 
    # @param [Hash] opts the optional parameters
    # @return [Template]
    def get_template(template_id, opts = {})
      data, _status_code, _headers = get_template_with_http_info(template_id, opts)
      data
    end

    # Get a single template
    # @param template_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Template, Fixnum, Hash)>] Template data, response status code and response headers
    def get_template_with_http_info(template_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.get_template ...'
      end
      # verify the required parameter 'template_id' is set
      if @api_client.config.client_side_validation && template_id.nil?
        fail ArgumentError, "Missing the required parameter 'template_id' when calling PDFApi.get_template"
      end
      # resource path
      local_var_path = '/templates/{template_id}'.sub('{' + 'template_id' + '}', template_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Template')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#get_template\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Fetch the JSON schema for a template
    # @param template_id 
    # @param [Hash] opts the optional parameters
    # @return [Hash<String, Object>]
    def get_template_schema(template_id, opts = {})
      data, _status_code, _headers = get_template_schema_with_http_info(template_id, opts)
      data
    end

    # Fetch the JSON schema for a template
    # @param template_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Hash<String, Object>, Fixnum, Hash)>] Hash<String, Object> data, response status code and response headers
    def get_template_schema_with_http_info(template_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.get_template_schema ...'
      end
      # verify the required parameter 'template_id' is set
      if @api_client.config.client_side_validation && template_id.nil?
        fail ArgumentError, "Missing the required parameter 'template_id' when calling PDFApi.get_template_schema"
      end
      # resource path
      local_var_path = '/templates/{template_id}/schema'.sub('{' + 'template_id' + '}', template_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Hash<String, Object>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#get_template_schema\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get a list of all folders
    # @param [Hash] opts the optional parameters
    # @option opts [String] :parent_folder_id Filter By Folder Id
    # @return [Array<Folder>]
    def list_folders(opts = {})
      data, _status_code, _headers = list_folders_with_http_info(opts)
      data
    end

    # Get a list of all folders
    # @param [Hash] opts the optional parameters
    # @option opts [String] :parent_folder_id Filter By Folder Id
    # @return [Array<(Array<Folder>, Fixnum, Hash)>] Array<Folder> data, response status code and response headers
    def list_folders_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.list_folders ...'
      end
      # resource path
      local_var_path = '/folders/'

      # query parameters
      query_params = {}
      query_params[:'parent_folder_id'] = opts[:'parent_folder_id'] if !opts[:'parent_folder_id'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<Folder>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#list_folders\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get a list of all templates
    # @param [Hash] opts the optional parameters
    # @option opts [String] :query Search By Name
    # @option opts [String] :parent_folder_id Filter By Folder Id
    # @option opts [Integer] :page Default: 1
    # @option opts [Integer] :per_page Default: 50
    # @return [Array<Template>]
    def list_templates(opts = {})
      data, _status_code, _headers = list_templates_with_http_info(opts)
      data
    end

    # Get a list of all templates
    # @param [Hash] opts the optional parameters
    # @option opts [String] :query Search By Name
    # @option opts [String] :parent_folder_id Filter By Folder Id
    # @option opts [Integer] :page Default: 1
    # @option opts [Integer] :per_page Default: 50
    # @return [Array<(Array<Template>, Fixnum, Hash)>] Array<Template> data, response status code and response headers
    def list_templates_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.list_templates ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page'].nil? && opts[:'page'] < 1
        fail ArgumentError, 'invalid value for "opts[:"page"]" when calling PDFApi.list_templates, must be greater than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'per_page'].nil? && opts[:'per_page'] > 50
        fail ArgumentError, 'invalid value for "opts[:"per_page"]" when calling PDFApi.list_templates, must be smaller than or equal to 50.'
      end

      if @api_client.config.client_side_validation && !opts[:'per_page'].nil? && opts[:'per_page'] < 1
        fail ArgumentError, 'invalid value for "opts[:"per_page"]" when calling PDFApi.list_templates, must be greater than or equal to 1.'
      end

      # resource path
      local_var_path = '/templates'

      # query parameters
      query_params = {}
      query_params[:'query'] = opts[:'query'] if !opts[:'query'].nil?
      query_params[:'parent_folder_id'] = opts[:'parent_folder_id'] if !opts[:'parent_folder_id'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'per_page'] = opts[:'per_page'] if !opts[:'per_page'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<Template>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#list_templates\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Move a folder
    # @param folder_id 
    # @param move_folder_data 
    # @param [Hash] opts the optional parameters
    # @return [Folder]
    def move_folder_to_folder(folder_id, move_folder_data, opts = {})
      data, _status_code, _headers = move_folder_to_folder_with_http_info(folder_id, move_folder_data, opts)
      data
    end

    # Move a folder
    # @param folder_id 
    # @param move_folder_data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Folder, Fixnum, Hash)>] Folder data, response status code and response headers
    def move_folder_to_folder_with_http_info(folder_id, move_folder_data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.move_folder_to_folder ...'
      end
      # verify the required parameter 'folder_id' is set
      if @api_client.config.client_side_validation && folder_id.nil?
        fail ArgumentError, "Missing the required parameter 'folder_id' when calling PDFApi.move_folder_to_folder"
      end
      # verify the required parameter 'move_folder_data' is set
      if @api_client.config.client_side_validation && move_folder_data.nil?
        fail ArgumentError, "Missing the required parameter 'move_folder_data' when calling PDFApi.move_folder_to_folder"
      end
      # resource path
      local_var_path = '/folders/{folder_id}/move'.sub('{' + 'folder_id' + '}', folder_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(move_folder_data)
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Folder')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#move_folder_to_folder\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Move Template to folder
    # @param template_id 
    # @param move_template_data 
    # @param [Hash] opts the optional parameters
    # @return [Template]
    def move_template_to_folder(template_id, move_template_data, opts = {})
      data, _status_code, _headers = move_template_to_folder_with_http_info(template_id, move_template_data, opts)
      data
    end

    # Move Template to folder
    # @param template_id 
    # @param move_template_data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Template, Fixnum, Hash)>] Template data, response status code and response headers
    def move_template_to_folder_with_http_info(template_id, move_template_data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.move_template_to_folder ...'
      end
      # verify the required parameter 'template_id' is set
      if @api_client.config.client_side_validation && template_id.nil?
        fail ArgumentError, "Missing the required parameter 'template_id' when calling PDFApi.move_template_to_folder"
      end
      # verify the required parameter 'move_template_data' is set
      if @api_client.config.client_side_validation && move_template_data.nil?
        fail ArgumentError, "Missing the required parameter 'move_template_data' when calling PDFApi.move_template_to_folder"
      end
      # resource path
      local_var_path = '/templates/{template_id}/move'.sub('{' + 'template_id' + '}', template_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(move_template_data)
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Template')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#move_template_to_folder\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Rename a folder
    # @param folder_id 
    # @param rename_folder_data 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def rename_folder(folder_id, rename_folder_data, opts = {})
      rename_folder_with_http_info(folder_id, rename_folder_data, opts)
      nil
    end

    # Rename a folder
    # @param folder_id 
    # @param rename_folder_data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def rename_folder_with_http_info(folder_id, rename_folder_data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.rename_folder ...'
      end
      # verify the required parameter 'folder_id' is set
      if @api_client.config.client_side_validation && folder_id.nil?
        fail ArgumentError, "Missing the required parameter 'folder_id' when calling PDFApi.rename_folder"
      end
      # verify the required parameter 'rename_folder_data' is set
      if @api_client.config.client_side_validation && rename_folder_data.nil?
        fail ArgumentError, "Missing the required parameter 'rename_folder_data' when calling PDFApi.rename_folder"
      end
      # resource path
      local_var_path = '/folders/{folder_id}/rename'.sub('{' + 'folder_id' + '}', folder_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(rename_folder_data)
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#rename_folder\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Test Authentication
    # @param [Hash] opts the optional parameters
    # @return [AuthenticationSuccessResponse]
    def test_authentication(opts = {})
      data, _status_code, _headers = test_authentication_with_http_info(opts)
      data
    end

    # Test Authentication
    # @param [Hash] opts the optional parameters
    # @return [Array<(AuthenticationSuccessResponse, Fixnum, Hash)>] AuthenticationSuccessResponse data, response status code and response headers
    def test_authentication_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.test_authentication ...'
      end
      # resource path
      local_var_path = '/authentication'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AuthenticationSuccessResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#test_authentication\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a submission data request
    # @param data_request_id 
    # @param update_submission_data_request_data 
    # @param [Hash] opts the optional parameters
    # @return [UpdateDataRequestResponse]
    def update_data_request(data_request_id, update_submission_data_request_data, opts = {})
      data, _status_code, _headers = update_data_request_with_http_info(data_request_id, update_submission_data_request_data, opts)
      data
    end

    # Update a submission data request
    # @param data_request_id 
    # @param update_submission_data_request_data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(UpdateDataRequestResponse, Fixnum, Hash)>] UpdateDataRequestResponse data, response status code and response headers
    def update_data_request_with_http_info(data_request_id, update_submission_data_request_data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PDFApi.update_data_request ...'
      end
      # verify the required parameter 'data_request_id' is set
      if @api_client.config.client_side_validation && data_request_id.nil?
        fail ArgumentError, "Missing the required parameter 'data_request_id' when calling PDFApi.update_data_request"
      end
      # verify the required parameter 'update_submission_data_request_data' is set
      if @api_client.config.client_side_validation && update_submission_data_request_data.nil?
        fail ArgumentError, "Missing the required parameter 'update_submission_data_request_data' when calling PDFApi.update_data_request"
      end
      # resource path
      local_var_path = '/data_requests/{data_request_id}'.sub('{' + 'data_request_id' + '}', data_request_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(update_submission_data_request_data)
      auth_names = ['api_token_basic']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'UpdateDataRequestResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PDFApi#update_data_request\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

  end
end
