=begin
#API v1

#FormAPI is a service that helps you fill out and sign PDF templates.

OpenAPI spec version: v1

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 3.3.0-SNAPSHOT

=end

require 'date'

module FormAPI
  class Templatesv2Template
    attr_accessor :expiration_interval

    attr_accessor :public_web_form

    attr_accessor :webhook_url

    attr_accessor :editable_submissions

    attr_accessor :expire_submissions

    attr_accessor :expire_after

    attr_accessor :allow_additional_properties

    attr_accessor :document

    attr_accessor :name

    attr_accessor :public_submissions

    attr_accessor :slack_webhook_url

    attr_accessor :redirect_url

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'expiration_interval' => :'expiration_interval',
        :'public_web_form' => :'public_web_form',
        :'webhook_url' => :'webhook_url',
        :'editable_submissions' => :'editable_submissions',
        :'expire_submissions' => :'expire_submissions',
        :'expire_after' => :'expire_after',
        :'allow_additional_properties' => :'allow_additional_properties',
        :'document' => :'document',
        :'name' => :'name',
        :'public_submissions' => :'public_submissions',
        :'slack_webhook_url' => :'slack_webhook_url',
        :'redirect_url' => :'redirect_url'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'expiration_interval' => :'String',
        :'public_web_form' => :'BOOLEAN',
        :'webhook_url' => :'String',
        :'editable_submissions' => :'BOOLEAN',
        :'expire_submissions' => :'BOOLEAN',
        :'expire_after' => :'Float',
        :'allow_additional_properties' => :'BOOLEAN',
        :'document' => :'Templatesv2TemplateDocument',
        :'name' => :'String',
        :'public_submissions' => :'BOOLEAN',
        :'slack_webhook_url' => :'String',
        :'redirect_url' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'expiration_interval')
        self.expiration_interval = attributes[:'expiration_interval']
      end

      if attributes.has_key?(:'public_web_form')
        self.public_web_form = attributes[:'public_web_form']
      end

      if attributes.has_key?(:'webhook_url')
        self.webhook_url = attributes[:'webhook_url']
      end

      if attributes.has_key?(:'editable_submissions')
        self.editable_submissions = attributes[:'editable_submissions']
      end

      if attributes.has_key?(:'expire_submissions')
        self.expire_submissions = attributes[:'expire_submissions']
      end

      if attributes.has_key?(:'expire_after')
        self.expire_after = attributes[:'expire_after']
      end

      if attributes.has_key?(:'allow_additional_properties')
        self.allow_additional_properties = attributes[:'allow_additional_properties']
      end

      if attributes.has_key?(:'document')
        self.document = attributes[:'document']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'public_submissions')
        self.public_submissions = attributes[:'public_submissions']
      end

      if attributes.has_key?(:'slack_webhook_url')
        self.slack_webhook_url = attributes[:'slack_webhook_url']
      end

      if attributes.has_key?(:'redirect_url')
        self.redirect_url = attributes[:'redirect_url']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      expiration_interval_validator = EnumAttributeValidator.new('String', ['minutes', 'hours', 'days'])
      return false unless expiration_interval_validator.valid?(@expiration_interval)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] expiration_interval Object to be assigned
    def expiration_interval=(expiration_interval)
      validator = EnumAttributeValidator.new('String', ['minutes', 'hours', 'days'])
      unless validator.valid?(expiration_interval)
        fail ArgumentError, 'invalid value for "expiration_interval", must be one of #{validator.allowable_values}.'
      end
      @expiration_interval = expiration_interval
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          expiration_interval == o.expiration_interval &&
          public_web_form == o.public_web_form &&
          webhook_url == o.webhook_url &&
          editable_submissions == o.editable_submissions &&
          expire_submissions == o.expire_submissions &&
          expire_after == o.expire_after &&
          allow_additional_properties == o.allow_additional_properties &&
          document == o.document &&
          name == o.name &&
          public_submissions == o.public_submissions &&
          slack_webhook_url == o.slack_webhook_url &&
          redirect_url == o.redirect_url
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [expiration_interval, public_web_form, webhook_url, editable_submissions, expire_submissions, expire_after, allow_additional_properties, document, name, public_submissions, slack_webhook_url, redirect_url].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = FormAPI.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
